#include <iostream>
#include <string>
#include <vector>
#include <memory>
using namespace std;

// motivation for using the heap is it is dynamic
int main () {
    vector<int> x(1000);
    cout << "size of x = " << sizeof(x) << "\n";  //only 24 bytes instead of 4*1000!!!
    int* p = new int(8);  // allocate a new byte from the heap (naked pointer)
    cout << *p << "\n";
    int y = *p;
    cout << y << "\n";

    delete p; // be careful though; the heap has to be cleared explicitly! memory leaks!!!

    unique_ptr<int> q (new int(8)); // smart pointers that deletes themselves when destroyed
    cout << *q << "\n";
    int z = *q;
    cout << z << "\n";
}